import test from 'tape';
import webpack from 'webpack';
import baseConfig from '../webpack.config';

test('● Real Test Via Webpack & NodeJS', t => {
  const config = Object.assign({
    plugins: [
      new webpack.DefinePlugin({
        'process.env': {
          BROWSER: JSON.stringify(true)
        }
      })
    ]
  }, baseConfig);
  webpack(config, (err, stats) => {
    if ( err ) {
      t.fail(err);
      t.end();
      return;
    }
    let jsonStats = stats.toJson();
    if ( jsonStats.errors.length ) {
      t.fail('compile error');
      console.log(jsonStats.errors);
    } else {
      t.pass('compile successfully');
    }
    try {
      require('../css/test.css');
    } catch(e) {
      t.ok(
        e.name === 'SyntaxError' && e.message.includes('Unexpected token'),
        'occurs SyntaxError when require css in node'
      );
    }

    t.end();
  });
});



